// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniHTML/Forms.subproj/OHFormSelect.h,v 1.6 1998/12/05 01:33:31 wiml Exp $

#import "OHViewCell.h"
#import "OHFormElementProtocol.h"

@class OHForm, OHFormSelectOption;

@interface OHFormSelect : OHViewCell <OHFormElement>
{
    OHForm *form;
    NSString *name;
    NSArray *options;
    NSMutableArray *selectedOptions;
    OWScriptEventHandlerHolder *eventHandlers;
    NSLock *elementStateLock; /* protects options and selectedOptions */
}

+ (OHFormSelect *)selectWithForm:(OHForm *)aForm name:(NSString *)aName options:(NSArray *)someOptions visibleRows:(int)aRowCount allowMultiple:(BOOL)shouldAllowMultiple;

// OHFormSelectMultiple overrides these methods
- initWithForm:(OHForm *)aForm name:(NSString *)aName options:(NSArray *)someOptions;
// - (void)constructView;

- (OHFormSelectOption *)optionWithText:(NSString *)someText;

- (NSArray *)options;
- (NSArray *)selectedOptions;
- (void)resetSelectedOptions:(NSArray *)newSelection;

- (OHForm *)form;

@end

@interface OHFormSelect (SubclassesOnly)

/* called when the selectedOptions are changed programmatically */
/* must be called in the appkit thread */
- (void)updateUI;

/* called when the selectedOptions are changed by the user */
- (void)userDidChangeSelection;

/* elementStateLock must be held when calling these methods */
- (OHFormSelectOption *)l_optionWithText:(NSString *)someText;

/* if YES, there can be from 0..N items selected. If NO, there must be exactly 1 item selected. */
- (BOOL)allowsMultipleSelection;

@end
